// IsPalindrome.java, ©2017 by Josh Moyer <JMoyer@NODOMAIN.NET>
// All rights reserved.

public class IsPalindrome
{
	public enum Result
	{
		Is,
		Not,
		Null
	}
	
	static Result IsPalindrome(String theString)
	{
		int strLen = theString.length();
		int i;
		int oppIndex;
		char currentChar;
		
		if (strLen == 0) return Result.Null;
		for (i = 0 ; i < strLen / 2 ; i++)
		{
			currentChar = theString.charAt(i);
			oppIndex = strLen - i ;
			if (currentChar == theString.charAt(oppIndex -1)) continue;
			else return Result.Not;
		}
		return Result.Is;
	}
	
	private static class TestCase
	{
		public String TestInput;
		public Result TestResult;
		public TestCase(String Input, Result Result)
		{
			TestInput = Input;
			TestResult = Result;
		}
	}
	
	public static void main(String args[])
	{
		Result CurrentResult;

		TestCase[] TestCases = new TestCase[] {
			//new TestCase(null, Result.Null),
			new TestCase("", Result.Null),
			new TestCase(" ", Result.Is),
			new TestCase("  ", Result.Is),
			new TestCase("   ", Result.Is),
			new TestCase("A", Result.Is),
			new TestCase("AA", Result.Is),
			new TestCase("AB", Result.Not),
			new TestCase("AAA", Result.Is),
			new TestCase("AAB", Result.Not),
			new TestCase("ABA", Result.Is),
			new TestCase("radar", Result.Is),
			new TestCase("Radar", Result.Not),
			new TestCase("Rädar", Result.Not),
			new TestCase("1", Result.Is),
			new TestCase("12", Result.Not),
			new TestCase("123", Result.Not),
			new TestCase("121", Result.Is)
			};
			
		for (TestCase CurrentCase : TestCases)
		{
			CurrentResult = IsPalindrome(CurrentCase.TestInput);
			
			if (CurrentResult == CurrentCase.TestResult) continue;
			else System.out.println(CurrentCase.TestInput + " failed test.");
		}
	}
}